## GstRTSPOnvifMediaFactory

GstRTSPOnvifMediaFactory — A factory for ONVIF media pipelines

## Functions

GstRTSPMediaFactory * | gst_rtsp_onvif_media_factory_new ()
gboolean | gst_rtsp_onvif_media_factory_has_backchannel_support ()
void | gst_rtsp_onvif_media_factory_set_backchannel_bandwidth ()
guint | gst_rtsp_onvif_media_factory_get_backchannel_bandwidth ()
void | gst_rtsp_onvif_media_factory_set_backchannel_launch ()
gchar * | gst_rtsp_onvif_media_factory_get_backchannel_launch ()

## Types and Values

typedef | GstRTSPOnvifMediaFactory
typedef | GstRTSPOnvifMediaFactoryClass

## Description

The GstRTSPOnvifMediaFactory is responsible for creating or recycling GstRTSPMedia objects based on the passed URL. Different to GstRTSPMediaFactory, this supports special ONVIF features and can create GstRTSPOnvifMedia in addition to normal GstRTSPMedia.

Special ONVIF features that are currently supported is a backchannel for the client to send back media to the server in a normal PLAY media, see `gst_rtsp_onvif_media_factory_set_backchannel_launch()` and `gst_rtsp_onvif_media_factory_set_backchannel_bandwidth()`.

## Functions

### gst_rtsp_onvif_media_factory_new ()

    GstRTSPMediaFactory *
    gst_rtsp_onvif_media_factory_new (void);

Create a new GstRTSPOnvifMediaFactory

#### Returns

A new GstRTSPOnvifMediaFactory

Since: 1.14

### gst_rtsp_onvif_media_factory_has_backchannel_support ()

    gboolean
    gst_rtsp_onvif_media_factory_has_backchannel_support
                                   (GstRTSPOnvifMediaFactory *factory);

Returns `TRUE` if an ONVIF backchannel is supported by the media factory.

#### Parameters

factory | a GstRTSPMediaFactory |

#### Returns

`TRUE` if an ONVIF backchannel is supported by the media factory.

Since: 1.14

### gst_rtsp_onvif_media_factory_set_backchannel_bandwidth ()

    void
    gst_rtsp_onvif_media_factory_set_backchannel_bandwidth
                                   (GstRTSPOnvifMediaFactory *factory,
                                    guint bandwidth);

Set the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

#### Parameters

factory | a GstRTSPMediaFactory |
bandwidth | the bandwidth in bits per second |

Since: 1.14

### gst_rtsp_onvif_media_factory_get_backchannel_bandwidth ()

    guint
    gst_rtsp_onvif_media_factory_get_backchannel_bandwidth
                                   (GstRTSPOnvifMediaFactory *factory);

Get the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

#### Parameters

factory | a GstRTSPMediaFactory |

#### Returns

the configured/supported backchannel bandwidth.

Since: 1.14

### gst_rtsp_onvif_media_factory_set_backchannel_launch ()

    void
    gst_rtsp_onvif_media_factory_set_backchannel_launch
                                   (GstRTSPOnvifMediaFactory *factory,
                                    const gchar *launch);

The `gst_parse_launch()` line to use for constructing the ONVIF backchannel pipeline in the default prepare vmethod if requested by the client.

The pipeline description should return a GstBin as the toplevel element which can be accomplished by enclosing the description with brackets '(' ')'.

The description should return a pipeline with a single depayloader named depay_backchannel. A caps query on the depayloader's sinkpad should return all possible, complete RTP caps that are going to be supported. At least the payload type, clock-rate and encoding-name need to be specified.

Note: The pipeline part passed here must end in sinks that are not waiting until pre-rolling before reaching the PAUSED state, i.e. setting async=false on GstBaseSink. Otherwise the whole media will not be able to prepare.

#### Parameters

factory | a GstRTSPMediaFactory |
launch | the launch description |

Since: 1.14

### gst_rtsp_onvif_media_factory_get_backchannel_launch ()

    gchar *
    gst_rtsp_onvif_media_factory_get_backchannel_launch
                                   (GstRTSPOnvifMediaFactory *factory);

Get the `gst_parse_launch()` pipeline description that will be used in the default prepare vmethod for generating the ONVIF backchannel pipeline.

#### Parameters

factory | a GstRTSPMediaFactory |

#### Returns

the configured backchannel launch description. `g_free()` after usage.

[transfer full]

Since: 1.14

## Types and Values

### GstRTSPOnvifMediaFactory

    typedef struct GstRTSPOnvifMediaFactory GstRTSPOnvifMediaFactory;

Since: 1.14

### GstRTSPOnvifMediaFactoryClass

    typedef struct GstRTSPOnvifMediaFactoryClass GstRTSPOnvifMediaFactoryClass;

## See Also

GstRTSPMediaFactory, GstRTSPOnvifMedia